--*************************************************************
--	Live Palette editor for Sonic games
--	Made by Tribeam
--*************************************************************









	
function Palette_Tool()

		local Line = 0
		local Row = 0
		local ColorBox = {}
		local ColorBoxW = {}
		
		Palette.Main = Palette_Save(Addresses.Palette.Main)
		Palette.Water = Palette_Save(Addresses.Palette.Water)
	
		if PalTool == true then
			for Pal_Index = 0, 63 do
			
				Line = Dec_Round(Pal_Index / 16, 0)
				
				if Line == 0 then Row = Pal_Index end
				if Line == 1 then Row = Pal_Index - 16 end
				if Line == 2 then Row = Pal_Index - 32 end
				if Line == 3 then Row = Pal_Index - 48 end
				
				ColorBox = Palette_ColorBox(PALTOOL_X + (Row * PALTOOL_BOXSIZE), 
											PALTOOL_Y + (Line * PALTOOL_BOXSIZE), 
											Palette.Main[Pal_Index+1], 
											PALTOOL_BOXSIZE)
											
				ColorBoxW = Palette_ColorBox(PALTOOL_X + (Row * PALTOOL_BOXSIZE), 
											(PALTOOL_Y + 32) + (Line * PALTOOL_BOXSIZE), 
											Palette.Water[Pal_Index+1], 
											PALTOOL_BOXSIZE)
				if ColorBox.Clicked then
				
					SelectionBox.Index = Pal_Index
					SelectionBox.X = ColorBox.X
					SelectionBox.Y = ColorBox.Y
					SelectionBox.Palette = "Main"
					
				end
				
				if ColorBoxW.Clicked then
				
					SelectionBox.Index = Pal_Index
					SelectionBox.X = ColorBoxW.X
					SelectionBox.Y = ColorBoxW.Y
					SelectionBox.Palette = "Water"
					SelectionBox.Color = Palette.Water[SelectionBox.Index+1]
				end

			end
			
			if SelectionBox.Palette == "Main" then
			
				SelectionBox.Color = Palette.Main[SelectionBox.Index+1]
			
			end
			
			if SelectionBox.Palette == "Water" then
			
				SelectionBox.Color = Palette.Water[SelectionBox.Index+1]
			
			end
			
			
			
			
			gui.drawbox(SelectionBox.X - Half(PALTOOL_BOXSIZE) - 1, 
						SelectionBox.Y - Half(PALTOOL_BOXSIZE) - 1, 
						SelectionBox.X + Half(PALTOOL_BOXSIZE) + 1, 
						SelectionBox.Y + Half(PALTOOL_BOXSIZE) + 1, 
						SelectionBox.Color, 
						Theme.Selected)
		
			-- draw preview box
			gui.drawbox(PREVIEWX , PREVIEWY, PREVIEWX + PREVIEWW, PREVIEWY + PREVIEWH, SelectionBox.Color, {255,255,255,255})
				
			-- draw "Red" text and value
			gui.text(TEXT_REDX, TEXT_REDY, " Red", "#FFFFFF")
			gui.text(NUM_REDX, NUM_REDY, SelectionBox.Color[1], "#FFFFFF")
				
			-- draw "Green" text and value
			gui.text(TEXT_GREENX, TEXT_GREENY, "Green", "#FFFFFF")
			gui.text(NUM_GREENX, NUM_GREENY, SelectionBox.Color[2], "#FFFFFF")	
				
			-- draw "Blue" text and value
			gui.text(TEXT_BLUEX, TEXT_BLUEY, "Blue", "#FFFFFF")
			gui.text(NUM_BLUEX, NUM_BLUEY, SelectionBox.Color[3], "#FFFFFF")	
		
			-- Red buttons
			SelectionBox.Color[1] = Add_Button(PLUS_REDX, PLUS_REDY, {0,0,0,255}, {255,255,255,255}, SelectionBox.Color[1], 32, 0, 224)
			SelectionBox.Color[1] = Sub_Button(MINUS_REDX, MINUS_REDY, {0,0,0,255}, {255,255,255,255}, SelectionBox.Color[1], 32, 0, 224)
		
				-- Green buttons
			SelectionBox.Color[2] = Add_Button(PLUS_GREENX, PLUS_GREENY, {0,0,0,255}, {255,255,255,255}, SelectionBox.Color[2], 32, 0, 224)
			SelectionBox.Color[2] = Sub_Button(MINUS_GREENX, MINUS_GREENY, {0,0,0,255}, {255,255,255,255}, SelectionBox.Color[2], 32, 0, 224)
				
				-- Blue buttons
			SelectionBox.Color[3] = Add_Button(PLUS_BLUEX, PLUS_BLUEY, {0,0,0,255}, {255,255,255,255}, SelectionBox.Color[3], 32, 0, 224)
			SelectionBox.Color[3] = Sub_Button(MINUS_BLUEX, MINUS_BLUEY, {0,0,0,255}, {255,255,255,255}, SelectionBox.Color[3], 32, 0, 224)
		
			if SelectionBox.Palette == "Main" then
				Palette_SetColor(	Addresses.Palette.Main + (SelectionBox.Index * 2), 
									SelectionBox.Color[1],
									SelectionBox.Color[2],
									SelectionBox.Color[3])
									
				if Lock == true then				
					Palette.Main[SelectionBox.Index+1][1] = SelectionBox.Color[1]
					Palette.Main[SelectionBox.Index+1][2] = SelectionBox.Color[2]
					Palette.Main[SelectionBox.Index+1][3] = SelectionBox.Color[3]
				end
									
			end
			
			if SelectionBox.Palette == "Water" then
				Palette_SetColor(	Addresses.Palette.Water + (SelectionBox.Index * 2), 
									SelectionBox.Color[1],
									SelectionBox.Color[2],
									SelectionBox.Color[3])
			end
			
		end
							
							
							
end